#ifndef nitrogenstyleconfig_h
#define nitrogenstyleconfig_h

/*
Copyright (C) 2009 Hugo Pereira Da Costa <hugo.pereira@free.fr>
Copyright (C) 2003 Sandro Giessl <ceebx@users.sourceforge.net>

based on the Keramik configuration dialog:
Copyright (c) 2003 Maksim Orlovich <maksim.orlovich@kdemail.net>

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation
the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.

*/

#include <KComboBox>
#include <QtGui/QCheckBox>
#include <QtGui/QRadioButton>
#include <QtGui/QSlider>
#include <QtGui/QSpinBox>

class NitrogenStyleConfig: public QWidget
{
  Q_OBJECT

  public:

  //! constructor
  NitrogenStyleConfig(QWidget* parent);

  //! destructor
  ~NitrogenStyleConfig();

  //This signal and the next two slots are the plugin
  //page interface
  Q_SIGNALS:

  //! emmited when configuration is changes
  void changed(bool);

  public Q_SLOTS:

  //! save configuration
  void save();

  //! reset to defaults
  void defaults();

  //Everything below this is internal.
  protected Q_SLOTS:
  void updateChanged();

  protected:

  //! setup layout
  void setupUi();

  //! menu mode
  int menuMode() const;

  //! tab style
  int tabStyle() const;

  //! menubar animation
  int menuBarAnimation() const;

  //! menubar animation
  int menuAnimation() const;

  //! toolbar animation
  int toolBarAnimation() const;

  private:

  QCheckBox *_toolBarDrawItemSeparator;
  QCheckBox *_checkDrawX;

  QCheckBox *_viewDrawTriangularExpander;
  QCheckBox *_viewDrawTreeBranchLines;

  KComboBox *_tabStyle;

  QCheckBox *_scrollBarColored;
  QSlider *_scrollBarWidthSlider;
  QSpinBox *_scrollBarWidth;

  QRadioButton *_menuHighlightDark;
  QRadioButton *_menuHighlightStrong;
  QCheckBox *_menuHighlightSubtle;

  QCheckBox *_animations;
  QSlider *_animationsSlider;
  QSpinBox *_animationsDuration;

  QCheckBox *_stackedWidgetAnimations;
  KComboBox *_menuBarAnimation;
  KComboBox *_menuAnimation;
  KComboBox *_toolBarAnimation;

};

#endif // OXYGENCONF_H
